--[[******************************************
*
*	Multi Theft Auto - Admin Chat
*
*	adminchat.lua
*
*	Made by [DRuG]Dabombber
*
*	Version 1.1
*		- Checks ACL group exists
*		- More efficent itterations
*
**********************************************]]

local validKeys = {
	["mouse1"] = true ,
	["mouse2"] = true ,
	["mouse3 (middle)"] = true ,
	["mouse4"] = true ,
	["mouse5"] = true ,
	["mouse_wheel_up"] = true ,
	["mouse_wheel_down"] = true ,
	["arrow_l"] = true ,
	["arrow_u"] = true ,
	["arrow_r"] = true ,
	["arrow_d"] = true ,
	["0"] = true ,
	["1"] = true ,
	["2"] = true ,
	["3"] = true ,
	["4"] = true ,
	["5"] = true ,
	["6"] = true ,
	["7"] = true ,
	["8"] = true ,
	["9"] = true ,
	["a"] = true ,
	["b"] = true ,
	["c"] = true ,
	["d"] = true ,
	["e"] = true ,
	["f"] = true ,
	["g"] = true ,
	["h"] = true ,
	["i"] = true ,
	["j"] = true ,
	["k"] = true ,
	["l"] = true ,
	["m"] = true ,
	["n"] = true ,
	["o"] = true ,
	["p"] = true ,
	["q"] = true ,
	["r"] = true ,
	["s"] = true ,
	["t"] = true ,
	["u"] = true ,
	["v"] = true ,
	["w"] = true ,
	["x"] = true ,
	["y"] = true ,
	["z"] = true ,
	["num_0"] = true ,
	["num_1"] = true ,
	["num_2"] = true ,
	["num_3"] = true ,
	["num_4"] = true ,
	["num_5"] = true ,
	["num_6"] = true ,
	["num_7"] = true ,
	["num_8"] = true ,
	["num_9"] = true ,
	["num_mul"] = true ,
	["num_add"] = true ,
	["num_sep"] = true ,
	["num_sub"] = true ,
	["num_div"] = true ,
	["num_dec"] = true ,
	["F1"] = true ,
	["F2"] = true ,
	["F3"] = true ,
	["F4"] = true ,
	["F5"] = true ,
	["F6"] = true ,
	["F7"] = true ,
	["F8"] = true ,
	["F9"] = true ,
	["F10"] = true ,
	["F11"] = true ,
	["F12"] = true ,
	["backspace"] = true ,
	["tab"] = true ,
	["lalt"] = true ,
	["ralt"] = true ,
	["enter"] = true ,
	["space"] = true ,
	["pgup"] = true ,
	["pgdn"] = true ,
	["end"] = true ,
	["home"] = true ,
	["insert"] = true ,
	["delete"] = true ,
	["lshift"] = true ,
	["rshift"] = true ,
	["lctrl"] = true ,
	["rctrl"] = true ,
	["["] = true ,
	["]"] = true ,
	["pause"] = true ,
	["capslock"] = true ,
	["scroll"] = true ,
	[";"] = true ,
	[","] = true ,
	["-"] = true ,
	["."] = true ,
	["/"] = true ,
	["#"] = true ,
	["\\"] = true ,
	["="] = true
}

local hasAdmin = {}
local settings = {}

addEventHandler( "onResourceStart" , getResourceRootElement( ) ,
	function ( )
		-- Get the message colour
		local colour = get ( "MessageColour" )
		if ( type ( colour ) == "string" ) then
			settings.Red , settings.Green , settings.Blue = hextoint ( colour )
		end
		if ( settings.Red == nil or settings.Green == nil or settings.Blue == nil ) then
			outputServerLog ( "ADMINCHAT: Invalid configuration setting (adminchat.MessageColour)" )
			return
		end

		-- Get the message group
		settings.Group = get ( "MessageGroup" )
		if ( type ( settings.Group ) ~= "string" or settings.Group == "" or not aclGetGroup ( settings.Group ) ) then
			outputServerLog ( "ADMINCHAT: Invalid configuration setting (adminchat.MessageGroup)" )
			return
		end

		-- Get the message key
		settings.Key = get ( "MessageKey" )
		if ( type ( settings.Key ) ~= "string" or settings.Key == "" or validKeys[settings.Key] == nil) then
			outputServerLog ( "ADMINCHAT: Invalid configuration setting (adminchat.Key)" )
			return
		end

		-- Enable the chatbox for already logged in players
		for _ , player in ipairs ( getElementsByType ( "player" ) ) do
			local account = getPlayerAccount ( player )
			if ( ( not isGuestAccount ( account ) ) and isObjectInACLGroup ( "user." .. getAccountName ( account ) , aclGetGroup ( settings.Group ) ) ) then
				bindKey ( player , settings.Key , "down" , "chatbox" , "adminChat" )
				hasAdmin[player] = true
			end
		end
		
		addEventHandler( "onResourceStop" , getResourceRootElement( ) ,
			function ( )
				for toplayer , _ in pairs( hasAdmin ) do 
					unbindKey ( player , settings.Key , "down" , "chatbox" )
				end
			end
		)

		-- Set the chatbox to be enabled when a player logs in
		addEventHandler( "onPlayerLogin" , getRootElement( ) ,
			function ( )
				local account = getPlayerAccount ( source )
				if ( ( not isGuestAccount ( account ) ) and isObjectInACLGroup ( "user." .. getAccountName ( account ) , aclGetGroup ( settings.Group ) ) ) then
					bindKey ( source , settings.Key , "down" , "chatbox" , "adminChat" )
					hasAdmin[source] = true
				end
			end
		)

		-- Disable the chatbox when a player logs out
		addEventHandler( "onPlayerLogout" , getRootElement( ) ,
			function ( )
				if( hasAdmin[source] ) then
					unbindKey ( source , settings.Key , "down" , "chatbox" )
					hasAdmin[source] = nil
				end
			end
		)

		-- Reset variables when the player disconnects
		addEventHandler( "onPlayerQuit" , getRootElement( ) ,
			function ( )
				if( hasAdmin[source] ) then
					--unbindKey ( source , settings.Key , "down" , "chatbox" )
					hasAdmin[source] = nil
				end
			end
		)

		-- Send a message to all admins when the chatbox is used
		addCommandHandler( "adminChat" ,
			function ( player , cmd , ... )
				if ( not hasAdmin[player] ) then return end
				local message = "<Admin Chat> " .. getPlayerName ( player ) .. ": " .. table.concat( {...} , " " )
				for toplayer , _ in pairs( hasAdmin ) do 
					outputChatBox ( message , toplayer , settings.Red , settings.Green , settings.Blue )
				end
			end
			, false , false
		)
	end
)

function hextoint ( hexString )
	if ( type ( hexString ) ~= "string" ) then return end
	local _ , _ , red , green , blue = string.find ( hexString , "^#(%x%x)(%x%x)(%x%x)$" )
	if ( red == nil or green == nil or blue == nil ) then return end
	return tonumber ( "0x" .. red ) , tonumber ( "0x" .. green ) , tonumber ( "0x" .. blue )
end

